/* Mini clone of the Unix chown command. */

#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <stdio.h>

void usage (void);

int main (int argc, char *argv[])
{
  struct passwd *pwd;
  unsigned long i;

  /* Must supply user name and at least one file/drawer name. */
  if (argc <= 2)
  {
    usage ();
    return (5);
  }

  if (!((pwd = getpwnam (argv[1]))))
  {
    usage ();
    return (5);
  }

  for (i = 1; i < argc; i ++)
  {
    chown (argv[i], pwd->pw_uid, (gid_t) -1);
  }
  return (0);
}

void usage (void)
{
  puts ("Usage: minichown userid file ...");
}
